package cn.com.qmth.examcloud.core.oe.student.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import cn.com.qmth.examcloud.core.oe.student.dao.entity.ExamRecordDataEntity;

/**
 * @Description 考试记录
 * @Author lideyin
 * @Date 2019/12/9 18:00
 * @Version 1.0
 */
@Repository
public interface ExamRecordDataRepo extends JpaRepository<ExamRecordDataEntity, Long>, JpaSpecificationExecutor<ExamRecordDataEntity> {
    @Query(value = "select *  from ec_oes_exam_record_data where (batch_num is null or batch_num!=?1) and id>?2  "
    		+ " and (sync_status is null or sync_status ='UNSYNC') and exam_record_status!='EXAM_ERROR' "
    		+ " order by id limit ?3 ",nativeQuery = true)
    List<ExamRecordDataEntity> getLimitExamRecordDataList(Long batchNum, Long startId, Integer size);

    @Modifying
    @Query(value = "update ec_oes_exam_record_data set batch_num=?1 where id=?2", nativeQuery = true)
    int updateBatchNumById(Long batchNum, Long id);

    @Modifying
    @Query(value = "update ec_oes_exam_record_data set exam_record_status=?1 where id=?2", nativeQuery = true)
    int updateExamRecordStatusById(String examRecordStatus, Long id);

    @Modifying
    @Query(value = "update ec_oes_exam_record_data set sync_status=?1 where id=?2", nativeQuery = true)
    int updateExamRecordSyncStatusById(String syncStatus, Long id);

    @Query(value = "SELECT c.name from ec_oes_exam_record_data d LEFT JOIN ec_b_course c ON d.course_id = c.id " +
            "WHERE d.id = ?1", nativeQuery = true)
    String findCourseNameById(Long id);
    
    @Query(value = "select t.id from ec_oes_exam_record_data t where t.base_paper_id=?1 limit 1", nativeQuery = true)
    Long getRecordIdByPaperId(String basePaperId);
}
