package cn.com.qmth.examcloud.core.oe.student.service;

import cn.com.qmth.examcloud.core.oe.student.bean.GetFaceVerifyTokenInfo;
import cn.com.qmth.examcloud.core.oe.student.dao.entity.ExamFaceLivenessVerifyEntity;

import java.util.List;


/**
 * @Description 活体检测服务接口
 * @Author lideyin
 * @Date 2019/12/12 15:56
 * @Version 1.0
 */
public interface ExamFaceLivenessVerifyService {

    /**
     * 保存活体检测信息
     *
     * @param examRecordDataId
     */
    ExamFaceLivenessVerifyEntity saveFaceVerify(Long examRecordDataId);

    /**
     * 使用考试记录id查询人脸活体检测信息
     *
     * @param examRecordDataId
     * @return
     */
    List<ExamFaceLivenessVerifyEntity> listFaceVerifyByExamRecordId(Long examRecordDataId);

    /**
     * 人脸检测完成后回调处理
     *
     * @param resultJson
     * @return
     */
    ExamFaceLivenessVerifyEntity faceIdNotify(String resultJson);

    /**
     * 向faceId发起检测请求，返回token
     *
     * @return
     */
    GetFaceVerifyTokenInfo getFaceVerifyToken(Long studentId, String bizNo);

    ExamFaceLivenessVerifyEntity saveFaceVerifyByExamRecordDataId(Long examRecordDataId);

    /**
     * 根据ID查询
     *
     * @param id
     * @return
     */
    ExamFaceLivenessVerifyEntity findFaceVerifyById(Long id);

    /**
     * 人脸检测超时处理
     *
     * @param examRecordDataId
     */
    void faceTestTimeOut(Long examRecordDataId);

    /**
     * 人脸活体检测结束处理
     *
     * @param examRecordDataId
     * @param studentId
     * @param result
     */
    void faceTestEndHandle(Long examRecordDataId, Long studentId, String result);

    /**
     * 断点续考，获取活体检测开启时间
     *
     * @param examId
     * @param examRecordDataId
     * @param usedMinute 考试已用的分钟数
     * @return
     */
    Integer getFaceLivenessVerifyMinute(Long rootOrgId, Long orgId, Long examId,
                                        Long studentId, Long examRecordDataId, Integer usedMinute);

}

