package cn.com.qmth.examcloud.core.oe.student.service;

import cn.com.qmth.examcloud.core.oe.student.bean.FaceBiopsyInfo;
import cn.com.qmth.examcloud.core.oe.student.bean.SaveFaceBiopsyResultReq;
import cn.com.qmth.examcloud.core.oe.student.bean.SaveFaceBiopsyResultResp;
import cn.com.qmth.examcloud.core.oe.student.dao.enums.FaceBiopsyType;

/**
 * @Description 人脸活体检测接口
 * @Author lideyin
 * @Date 2019/10/14 10:54
 * @Version 1.0
 */
public interface FaceBiopsyService {

    /**
     * 获取人脸活体检测基本信息
     *
     * @param rootOrgId        学校id
     * @param examRecordDataId 考试记录id
     */
    FaceBiopsyInfo getFaceBiopsyInfo(Long rootOrgId, Long examRecordDataId, FaceBiopsyType faceBiopsyType);

    /**
     * 保存活体检测结果
     * @param req
     * @return
     */
    SaveFaceBiopsyResultResp saveFaceBiopsyResult(SaveFaceBiopsyResultReq req, Long studentId);

    /**
     * 获取人脸活体检测开始分钟数
     * @param examRecordDataId 考试记录id
     * @return Integer
     */
    Integer calculateFaceBiopsyStartMinute(Long examRecordDataId);
}
