package cn.com.qmth.examcloud.core.oe.student.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.oe.student.service.ExamBossService;
import cn.com.qmth.examcloud.support.examing.ExamBoss;
import cn.com.qmth.examcloud.support.redis.RedisKeyHelper;
import cn.com.qmth.examcloud.web.redis.RedisClient;

/**
 * @author chenken
 * @date 2018/8/15 9:24
 * @company QMTH
 * @description 考试会话服务实现
 */
@Service("examBossService")
public class ExamBossServiceImpl implements ExamBossService {

	@Autowired
	private RedisClient redisClient;

	@Override
	public void saveExamBoss(Long examStudentId, ExamBoss eb) {
		String key = RedisKeyHelper.getBuilder().examBossKey(examStudentId);
		redisClient.set(key, eb, 2592000);
	}

	@Override
	public ExamBoss getExamBoss(Long examStudentId) {
		String key = RedisKeyHelper.getBuilder().examBossKey(examStudentId);
		return redisClient.get(key, ExamBoss.class);
	}

	@Override
	public void deleteExamBoss(Long examStudentId) {
		String key = RedisKeyHelper.getBuilder().examBossKey(examStudentId);
		redisClient.delete(key);
	}
}
