package cn.com.qmth.examcloud.core.oe.student.service.impl;

import cn.com.qmth.examcloud.core.oe.student.service.ExamFileAnswerService;
import cn.com.qmth.examcloud.support.examing.ExamFileAnswer;
import cn.com.qmth.examcloud.web.redis.RedisClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description 文件作答实现类
 * @Author lideyin
 * @Date 2019/12/13 18:57
 * @Version 1.0
 */
@Service("examFileAnswerService")
public class ExamFileAnswerServiceImpl implements ExamFileAnswerService {
    @Autowired
    private RedisClient redisClient;

    /**
     * 保存文件作答结果
     *
     * @param fileAnswerId
     * @param examFileAnswer
     * @return 返回主键id
     */
    @Override
    public void saveFileAnswer(String fileAnswerId, ExamFileAnswer examFileAnswer) {
        redisClient.set(fileAnswerId, examFileAnswer, 24 * 60 * 60);
    }

    /**
     * 删除文件作答记录
     *
     * @param fileAnswerId
     */
    @Override
    public void deleteFileAnswer(String fileAnswerId) {
        redisClient.delete(fileAnswerId);
    }

    /**
     * 获取文件作答结果
     *
     * @param fileAnswerId
     * @return
     */
    @Override
    public ExamFileAnswer getFileAnswer(String fileAnswerId) {
        return redisClient.get(fileAnswerId,ExamFileAnswer.class);
    }
}
