package cn.com.qmth.examcloud.core.oe.student.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.oe.student.service.ExamingSessionService;
import cn.com.qmth.examcloud.support.examing.ExamingSession;
import cn.com.qmth.examcloud.support.redis.RedisKeyHelper;
import cn.com.qmth.examcloud.web.redis.RedisClient;

/**
 * @author chenken
 * @date 2018/8/15 9:24
 * @company QMTH
 * @description 考试会话服务实现
 */
@Service("examingSessionService")
public class ExamingSessionServiceImpl implements ExamingSessionService {

    @Autowired
    private RedisClient redisClient;

    @Override
    public void saveExamingSession(Long studentId, ExamingSession examingSession) {
        String key = RedisKeyHelper.getBuilder().examingSessionKey(studentId);
        redisClient.set(key,examingSession,2592000);
    }

    @Override
    public ExamingSession getExamingSession(Long studentId) {
        String key = RedisKeyHelper.getBuilder().examingSessionKey(studentId);
        return redisClient.get(key,ExamingSession.class);
    }

    @Override
    public void deleteExamingSession(Long studentId) {
        String key = RedisKeyHelper.getBuilder().examingSessionKey(studentId);
        redisClient.delete(key);
    }
}
